;==============================================================================
;
; MSX1 X^[tH[X Ge_ŉ
;
;==============================================================================
val_0041_in_rom_0027	equ	init0
val_0141_in_rom_03AF	equ	editor

val_00_in_rom_2167		equ	#c3
val_0000_in_rom_2168	equ	enemy_bullet_move

val_005c_in_rom_3105	equ	update_bg_color_from_main

org		#ba0c


;================================================================
;	_Ńp^[
;================================================================
color_tbl:
		db	12,1,12,1,12,1,12,1,12,1,12,1,12,1,12,1


bg_color_tbl:
		db	0,6,0,1,4,14,15,1,2,4,15,6,11,3


org_bg_color_tbl:
		db	0,6,0,1,4,14,15,1,2,4,15,6,11,3




;================================================================
;	
;================================================================
allready_init	equ	#38
init0:
		call	#0041
init:
		ld		a,(#ee12)
		cp		allready_init
		ret		z

		ld		hl,color_tbl
		ld		de,#ee00
		ld		bc,#0010
		ldir
		ld		hl,bg_color_tbl
		ld		de,#ee20
		ld		bc,colors_of_bg
		ldir
		xor		a
		ld		(#ee10),a
		ld		(#ee11),a
		ld		a,allready_init
		ld		(#ee12),a
		ret




;================================================================
;	Geړ
;================================================================
enemy_bullet_move:
		; get current color
		ld		hl,#ee10
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		ld		l,a
		ld		a,(hl)
		ld		ixl,a

		ld		hl,#e54e+#06
		ld		de,#e694+2
		ld		bc,#06ff

		; get current pattern
		ld		a,(de)
		xor		#14 xor #fc
		ld		ixh,a
		ld		e,#94

	_lp:
		ldi
		ld		a,l
		sub		#07
		ld		l,a

		ldi
		ld		a,l
		add		a,#06
		ld		l,a

		; switch pattern
		ld		a,ixh
		ld		(de),a
		inc		e

		; switch color
		ld		a,ixl
		ld		(de),a
		inc		e

		; next
		djnz	_lp
		ret




;================================================================
;	wiFXV
;================================================================
bgc_base	equ		#94d4
update_bg_color_from_main:
		call	#005c
		call	update_bg_color
		jp		update_bg_color_postproc

update_bg_color:
		ld		de,bgc_base+8
		ld		hl,#2000+8
		ld		bc,28*8
		exx
		ld		hl,org_bg_color_tbl
		ld		de,#ee20
		ld		iy,colors_of_rock
		exx
		call	update_bg_color_sub

		ld		de,bgc_base+29*8
		ld		hl,#2000+29*8
		ld		bc,67*8
		exx
		ld		hl,org_bg_color_tbl+colors_of_rock
		ld		de,#ee20+colors_of_rock
		ld		iy,colors_of_wall
		exx
		call	update_bg_color_sub

		ld		de,bgc_base+3*32*8
		ld		hl,#2000+3*32*8
		ld		bc,28*8
		exx
		ld		hl,org_bg_color_tbl+colors_of_rock+colors_of_wall
		ld		de,#ee20+colors_of_rock+colors_of_wall
		ld		iy,colors_of_pane
		exx
		call	update_bg_color_sub

update_bg_color_postproc:
		ld		hl,#2000
		ld		de,#ed00
		ld		b,#8
	_lpH:
		push	bc

		push	hl
		push	de
		ld		bc,#0100
		call	#0059
		pop		de
		pop		hl

		ex		de,hl
		ld		b,2
	_lpL:
		ld		a,d
		add		a,#08
		ld		d,a
		push	bc
		push	de
		push	hl
		ld		bc,#0100
		call	#005c
		pop		hl
		pop		de
		pop		bc
		djnz	_lpL
		ex		de,hl

		ld		a,h
		add		a,#f1
		ld		h,a

		pop		bc
		djnz	_lpH
		ret


update_bg_color_sub:
		inc		c
		dec		c
		jr		z,_0ck
		inc		b
	_0ck:
		push	bc
		ld		b,c
		jr		_lpL
	_lpH:
		push	bc
		ld		b,0
	_lpL:
		ld		a,(de)

		exx
		ld		b,iyl
		call	update_bg_color_sub_sub
		ld		c,a
		exx

		ld		a,(de)
		rra
		rra
		rra
		rra

		exx
		ld		b,iyl
		call	update_bg_color_sub_sub
		rla
		rla
		rla
		rla
		and		#f0
		or		c
		exx

		call	#004d
		inc		hl
		inc		de
		djnz	_lpL
		pop		bc
		djnz	_lpH
		ret

update_bg_color_sub_sub:
		push	hl
		push	de
		and		#f
	_lp:
		cp		(hl)
		jr		z,_cnv
		inc		hl
		inc		de
		djnz	_lp
		jr		_ret
	_cnv:
		ld		a,(de)
	_ret:
		pop		de
		pop		hl
		ret




;================================================================
;	ҏW[h؂ւ
;================================================================
editor:
		ld		a,#6
		call	#0141
		bit		5,a
		jp		z,enemy_bullet_editor
		bit		6,a
		jp		z,bg_color_editor
		ld		a,#7
		call	#0141
		bit		0,a
		jp		z,tape_save
		bit		1,a
		jp		z,tape_load
		ret


editor_setup:
		ld		a,(#0007)
		ld		c,a
		inc		c
		ld		a,#06+1
		out		(c),a
		ld		a,#80+2
		out		(c),a

		ld		hl,#1c00
		ld		bc,#300
		ld		a,#0
		call	#0056

		ld		hl,#1b00
		ld		a,#d0
		jp		#004d


editor_close:
		rept	4
		halt
		call	get_key
		jr		nz,editor_close
		endm

		ld		a,(#0007)
		ld		c,a
		inc		c
		ld		a,#06
		out		(c),a
		ld		a,#80+2
		out		(c),a

		ld		hl,#1b00
		ld		a,(#e680)
		call	#004d

		ld		a,#ff
		ret




;================================================================
;	GeFҏW[h
;================================================================
enemy_bullet_editor:
		call	editor_setup

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jp		z, editor_close

		ld		hl,#ee10
		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		dec		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		#1c
		jr		nz,_not_right
		ld		l,(hl)
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_right:
		cp		#1d
		jr		nz,_not_left
		ld		l,(hl)
		ld		a,(hl)
		dec		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_left:
		cp		'0'
		jr		c,_not_0_9
		cp		'9'+1
		jr		nc,_not_0_9
		sub		'0'
		jr		_0_9_A_Z
	_not_0_9:
		cp		'a'
		jr		c,_main_loop
		cp		'f'+1
		jr		nc,_main_loop
		sub		'a'-10
		jr		_0_9_A_Z
	_not_a_z:
		cp		'A'
		jr		c,_main_loop
		cp		'F'+1
		jr		nc,_main_loop
		sub		'A'-10
	_0_9_A_Z:
		ld		l,(hl)
		ld		(hl),a
	_key_off_wait:
		call	update_enemy_bullet_editor
		call	get_key
		jr		nz,_key_off_wait
		jr		_main_loop




;==============================================================================
;	GeFҏW[h\
;==============================================================================
update_enemy_bullet_editor:
		ld		hl,tx_header
		ld		de,#0024
		call	put_str

		ld		de,#0064
		ld		b,#10
	_loop:
		ld		a,#10
		sub		b
		ld		c,a

		ld		a,(#ee10)
		cp		c
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str

		inc		de
		inc		de

		call	put_number
		
		ld		a,#0a
		call	add_de_a

		ld		h,#ee
		ld		l,c
		ld		a,(hl)
		call	put_color_name

		ld		a,#20-2-#a
		call	add_de_a
		djnz	_loop

		ret




;================================================================
;	wiFҏW[h
;================================================================
bg_color_editor:
		call	editor_setup

		ld		hl,#1c00
		ld		b,#80
	_list_pcg:
		ld		a,#80
		sub		b
		call	#004d
		inc		hl
		djnz	_list_pcg

		ld		hl,tx_bge_lb0
		ld		de,#00c6
		ld		b,colors_of_bg
	_list_label:
		call	put_str
		ld		a,#6
		call	add_hl_a
		ld		a,#20
		call	add_de_a
		djnz	_list_label

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jr		z,_exit

		ld		hl,#ee11

		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		or		a
		jr		nz,_not_top
		ld		a,colors_of_bg
	_not_top:
		dec		a
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		cp		colors_of_bg
		jr		nz,_not_btm
		xor		a
	_not_btm:
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		#1c
		jr		nz,_not_right
		call	get_current_bg_color
		inc		a
		jr		_update
	_not_right:
		cp		#1d
		jr		nz,_not_left
		call	get_current_bg_color
		dec		a
		jr		_update
	_not_left:
		cp		'0'
		jr		c,_not_0_9
		cp		'9'+1
		jr		nc,_not_0_9
		sub		'0'
		jr		_0_9_A_Z
	_not_0_9:
		cp		'a'
		jr		c,_main_loop
		cp		'f'+1
		jr		nc,_main_loop
		sub		'a'-10
		jr		_0_9_A_Z
	_not_a_z:
		cp		'A'
		jr		c,_main_loop
		cp		'F'+1
		jr		nc,_main_loop
		sub		'A'-10
	_0_9_A_Z:
		push	af
		call	get_current_bg_color
		pop		af
	_update:
		and		#f
		ld		(hl),a
		call	update_bg_color
	_key_off_wait:
		call	update_bg_color_editor
		call	get_key
		jr		nz,_key_off_wait
		jr		_main_loop

	_exit:
		call	update_bg_color_postproc
		jp		editor_close


get_current_bg_color:
		ld		hl,#ee11
		ld		a,(hl)
		add		a,#20
		ld		l,a
		ld		a,(hl)
		ret

update_bg_color_editor:
		ld		de,#00c4
		ld		bc,colors_of_bg*256

	_loop:
		ld		a,(#ee11)
		cp		c
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str

		ld		a,#0a
		call	add_de_a

		ld		a,c
		ld		hl,#ee20
		call	add_hl_a
		ld		a,(hl)
		call	put_color_name

		ld		a,#20-#0a
		call	add_de_a
		inc		c
		djnz	_loop

		ret




;==============================================================================
;	#FFI[̏o	hl:src	de:vram ofs
;==============================================================================
put_str:
		push	hl
		push	de
		push	bc
		ex		de,hl
		ld		bc,#1c00;(#f3c7)
		add		hl,bc
		ex		de,hl
		call	#46a5
		pop		bc
		pop		de
		pop		hl
		ret

;==============================================================================
;	F̏o	a:color code de:vram ofs
;==============================================================================
put_color_name:
		push	hl
		ld		l,a
		add		a,a
		add		a,a
		add		a,a
		add		a,l
		ld		hl,tx_c0
		call	add_hl_a
		call	put_str
		pop		hl
		ret

;==============================================================================
;	l̏o	a:0-9a-f de:vram ofs
;==============================================================================
put_number:
		push	bc
		ld		a,c
		add		a,a
		add		a,c
		ld		hl,tx_0
		call	add_hl_a
		call	put_str
		pop		bc
		ret

;==============================================================================
;	hl+=a
;==============================================================================
add_hl_a:
		add		a,l
		ld		l,a
		ret		nc
		inc		h
		ret
;==============================================================================
;	de+=a
;==============================================================================
add_de_a:
		add		a,e
		ld		e,a
		ret		nc
		inc		d
		ret
;==============================================================================
;	L[
;==============================================================================
get_key:
		call	#009c
		ret		z
		call	#009f
		or		a
		ret




;================================================================
;	e[vI
;================================================================
tape_end:
		ei
		ld		b,#40
	_lp:
		halt
		djnz	_lp
		call	update_bg_color
		call	update_bg_color_postproc
		jp		editor_close


;================================================================
;	e[vǂݍ
;================================================================
tape_load:
		call	editor_setup

		ld		hl,tx_tape_r
		ld		de,#0146
		call	put_str

		call	#00e1
		jr		c,_err_o

		ld		hl,#ee00
		ld		b,#10
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,#ee20
		ld		b,#10
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,#e3d5
		ld		b,#3
		call	tape_load_sub
		jr		c,_err_r

	_end:
		call	#00e7
		jp		tape_end

	_err_o:
		ld		hl,tx_tape_eo
		jr		_err
	_err_r:
		ld		hl,tx_tape_er
	_err:
		ld		de,#0168
		call	put_str
		jp		_end


tape_load_sub:
	_lp:
		exx
		call	#00e4
		ret		c
		exx
		ld		(hl),a
		inc		l
		djnz	_lp
		xor		a
		ret


;================================================================
;	e[vۑ
;================================================================
tape_save:
		call	editor_setup

		ld		hl,tx_tape_w
		ld		de,#0146
		call	put_str

		call	#00ea
		jr		c,_err_o

		ld		hl,#ee00
		ld		b,#10
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,#ee20
		ld		b,#10
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,#e3d5
		ld		b,#3
		call	tape_save_sub
		jr		c,_err_w

	_end:
		call	#00f0
		jp		tape_end

	_err_o:
		ld		hl,tx_tape_eo
		jr		_err
	_err_w:
		ld		hl,tx_tape_ew
	_err:
		ld		de,#0168
		call	put_str
		jp		_end


tape_save_sub:
	_lp:
		ld		a,(hl)
		exx
		call	#00ed
		ret		c
		exx
		inc		l
		djnz	_lp
		xor		a
		ret




;==============================================================================
;	
;==============================================================================
tx_header:	db	"FRAME@ENEMY\\BULLET\\COLOR",#FF

tx_space:	db	"@",#FF
tx_cursor:	db	"?",#FF

tx_0:	db	"00",#FF
tx_1:	db	"01",#FF
tx_2:	db	"02",#FF
tx_3:	db	"03",#FF
tx_4:	db	"04",#FF
tx_5:	db	"05",#FF
tx_6:	db	"06",#FF
tx_7:	db	"07",#FF
tx_8:	db	"08",#FF
tx_9:	db	"09",#FF
tx_A:	db	"10",#FF
tx_B:	db	"11",#FF
tx_C:	db	"12",#FF
tx_D:	db	"13",#FF
tx_E:	db	"14",#FF
tx_F:	db	"15",#FF

tx_c0:	db	"0\\BLACK@",#FF
tx_c1:	db	"1\\BLACK@",#FF
tx_c2:	db	"2\\GREEN@",#FF
tx_c3:	db	"3\\GREEN@",#FF
tx_c4:	db	"4\\BLUE@@",#FF
tx_c5:	db	"5\\BLUE@@",#FF
tx_c6:	db	"6\\RED@@@",#FF
tx_c7:	db	"7\\CYAN@@",#FF
tx_c8:	db	"8\\RED@@@",#FF
tx_c9:	db	"9\\RED@@@",#FF
tx_cA:	db	"A\\YELLOW",#FF
tx_cB:	db	"B\\YELLOW",#FF
tx_cC:	db	"C\\GREEN@",#FF
tx_cD:	db	"D\\PURPLE",#FF
tx_cE:	db	"E\\GRAY@@",#FF
tx_cF:	db	"F\\WHITE@",#FF

colors_of_rock	equ	2
colors_of_wall	equ	5
colors_of_pane	equ	7
colors_of_bg	equ	colors_of_rock+colors_of_wall+colors_of_pane
tx_bge_lb0:	db	"ROCK0",#FF
tx_bge_lb1:	db	"ROCK1",#FF
tx_bge_lb2:	db	"WALL0",#FF
tx_bge_lb3:	db	"WALL1",#FF
tx_bge_lb4:	db	"WALL2",#FF
tx_bge_lb5:	db	"WALL3",#FF
tx_bge_lb6:	db	"WALL4",#FF
tx_bge_lb7:	db	"PANE0",#FF
tx_bge_lb8:	db	"PANE1",#FF
tx_bge_lb9:	db	"PANE2",#FF
tx_bge_lbA:	db	"PANE3",#FF
tx_bge_lbB:	db	"PANE4",#FF
tx_bge_lbC:	db	"PANE5",#FF
tx_bge_lbD:	db	"PANE6",#FF

tx_tape_r:	db	"@@LOAD@FROM@TAPE@@",#FF
tx_tape_w:	db	"@@SAVE@TO@TAPE@@",#FF
tx_tape_eo:	db	"@@OPEN@ERROR@@",#FF
tx_tape_ew:	db	"@@WRITE@ERROR@@",#FF
tx_tape_er:	db	"@@READ@ERROR@@",#FF




filler:
	ds	#c000-filler
